<template>
  <div>
    <q-input v-model="city" label="miejscowość" @keyup="($event: KeyboardEvent) => { getCities($event) }" />
    <ul>
      <li v-for="(city, index) in cities" :key="index" @click="() => { setCity(index) }" :class="{
        selected: index === indexCity
      }">
        {{ city.name }} {{ city.province }}
      </li>
    </ul>
  </div>
</template>
<script setup lang="ts">
import { ref } from 'vue';

import { api } from 'boot/axios';

import City from '../interfaces/City';

defineOptions({
  name: 'AutocompleteCity'
})

const emit = defineEmits(['city']);

const city = ref<string>('');
const cityObject = ref<City | null>()
const cities = ref<City[]>([]);
const indexCity = ref<number>(-1);

function getCities($event: KeyboardEvent) {
  if ($event.key === 'ArrowUp') {
    if (indexCity.value === 0) {
      indexCity.value = cities.value.length;
    }
    indexCity.value = (indexCity.value - 1) % cities.value.length;
    return;
  }
  if ($event.key === 'ArrowDown') {
    indexCity.value = (indexCity.value + 1) % cities.value.length;
    return;
  }
  if ($event.key === 'Enter' && indexCity.value >= 0) {
    setCity(indexCity.value)
    return;
  }
  if (city.value.length < 3) {
    cities.value = [];
    return;
  }
  api.post('/city', { prefix: city.value })
    .then(({ data }) => {
      cities.value = data.selected

    })
}


function setCity(index: number) {
  cityObject.value = cities.value[index];
  city.value = cities.value[index].name + ' ' + cities.value[index].province;
  emit('city', cityObject.value)
  setTimeout(() => {
    indexCity.value = -1;
    cities.value = [];
  }, 1000);
}

</script>
<style scoped>
ul {
  position: absolute;
  z-index: 9999;
  display: flex;
  flex-direction: column;
  justify-content: left;
  width: initial;
  padding: 0px;
  background: rgba(250, 250, 250, .8);

  li {
    list-style-type: none;
    cursor: pointer;

    &.selected,
    &:hover {
      background: rgba(22, 22, 22, .7);
      color: #ffffff;
    }

    &.clicked {
      background: rgba(110, 110, 110, 1);
      color: #ffffff;
    }
  }
}
</style>
